------------------------
-- Les Aloufs DS v1.0 --
------------------------                              par Thermo_Nono

-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
-- Quelques fonctions utiles
--

function affichage()
   -- affichage du level
   screen.drawGradientRect(SCREEN_UP, 0, 0, 256, 192, couleur2, couleur2, couleur3, couleur3)
   screen.drawGradientRect(SCREEN_DOWN, 0, 0, 256, 192, couleur3, couleur3, couleur1, couleur1)
   screen.drawFillRect(SCREEN_DOWN, 76, 150, 180, 130, couleur0)
   screen.print(SCREEN_DOWN, 103, 137, "level "..level)
   -- affichage des aloufs --
   for bcl = 1,nbAloufs do                   
      if aloufsRestantes[bcl] == 1 then
         screen.blit(SCREEN_DOWN,10*bcl,10,alouf1)
      elseif aloufsRestantes[bcl] == 2 then
         screen.blit(SCREEN_DOWN,10*bcl,10,alouf0)
      end
   end
   -- affichage du texte --
   screen.print(SCREEN_UP, 10, 10, "Il y a "..countOnes.." aloufs en jeu.")
   screen.print(SCREEN_UP, 10, 20, "Vous avez slection "..countTwos.." alouf(s).")
   screen.print(SCREEN_UP, 10, 40, message)
   screen.print(SCREEN_UP, 10, 50, "Le but du jeu est de ne jamais", couleurtxtgreen)
   screen.print(SCREEN_UP, 10, 60, "prendre la dernire alouf.", couleurtxtgreen)
   screen.print(SCREEN_UP, 10, 90, "PARTIES GAGNEES", couleurtxtgreen)
   screen.printFont(SCREEN_UP, 45, 100, partiesGagnees, couleurtxtgreen, font)
   screen.print(SCREEN_UP, 150, 90, "PARTIES PERDUES", couleurtxtgreen)
   screen.printFont(SCREEN_UP, 185, 100, partiesPerdues, couleurtxtgreen, font)
   drawCommand(btValidation)
   drawCommand(btPlus)
   drawCommand(btMoins)
   render()
end

function definircouleurs(level)
   couleur3 = Color.new(level*3,3,30-level*3)
end

function temporisation(tempo)  -- c'est une temporisation 'tempo' est en ms
   tmr:reset()
   tmr:start()
   time = 0
   while time < tempo do
      time = tmr:time()
      affichage()
   end
end

-- Les deux fonctions qui suivent sont extraites de la lib StylusBox de Killer01
function newBox(x1, y1, x2, y2)
   Box = {}
   Box.x1 = x1
   Box.y1 = y1
   Box.x2 = x2
   Box.y2 = y2
   return Box
end
function Stylus.newPressinBox(Box, x, y)
   local ret = false
   if Stylus.newPress then
   if x > Box.x1 and x < Box.x2 and y > Box.y1 and y < Box.y2 then ret = true end
   return ret
   end
end

-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
-- Dclaration des variables
--
x = 256
y = 192
alouf0 = Image.load("imgs/alouf0.PNG", VRAM)  -- l'image de l'alouf slectionne
alouf1 = Image.load("imgs/alouf1.PNG", VRAM)  -- l'image de l'alouf en jeu
dofile("libs/CommandButton.lua")
btValidation = newCommand(56, 100, 200, 120)    -- cration des boutons 
btMoins = newCommand(56, 130, 76, 150)
btPlus = newCommand(180, 130, 200, 150)
changeTexte(btValidation, "Validation")
changeTexte(btPlus , "+")
changeTexte(btMoins , "-")
font = Font.load("other/BigBodoni.oft")
couleur0 = Color.new(12, 12, 21)
couleur1 = Color.new(30, 3, 3)
couleur2 = Color.new(3, 3, 30)
couleur3 = Color.new(8,3,8)
couleurtxtgreen = Color.new(3, 30, 30)
tmr = Timer.new()      -- pour que l'ordi ne joue pas trop vite
message = "Choisissez de 1  3 aloufs et validez."
level = 5
partiesGagnees = 0
partiesPerdues = 0

function reinit()
   selection = 0          -- indique combien d'aloufs sont slectionnes
   btValidation.switched = false
   nbAloufs = 24          -- indique le nombre d'aloufs en jeu en dbut de partie
   solution = {}          -- ce tableau contiendra la solution 
   for bcl = 0,nbAloufs/4,1 do
      solution[bcl+1] = 1+bcl*4
   end
   aloufsRestantes = {}   -- indiquera le nombre d'aloufs restantes et slectionnes :
   zonesCliquables = {}
   for bcl = 1,nbAloufs do       -- 0=alouf retire | 1=alouf en jeu | 2=alouf slectionne
      aloufsRestantes[bcl]=1     -- (au dbut elles sont toutes en jeu)
      zonesCliquables[bcl] = newBox(10*bcl,10,10*bcl+9,85) -- et on dfini les zones cliquables
   end                           
   countOnes = 0                            -- un compteur pour les 1
   countTwos = 0                            -- et un autre pour les 2
   chxordi = 0                              -- nombre d'aloufs prises par l'ordi
end

-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
-- Boucle principale
--
reinit()
while not Keys.newPress.Start do   
   Controls.read()                            -- Lecture de l'tat du stylet
   if Stylus.held then
      x = Stylus.X
      y = Stylus.Y
   end
   Stylus.heldinCommand(btPlus, x, y)  -- Savoir si on augmente le level
   Stylus.heldinCommand(btMoins, x, y) -- Savoir si on baisse le level
   if btPlus.switched then
      if level < 10 then level = level + 1 end
      definircouleurs(level)
      temporisation(300)
      btPlus.switched = false

   elseif btMoins.switched then
      if level > 1 then level = level - 1 end
      definircouleurs(level)
      temporisation(300)
      btMoins.switched = false

   end

   for bcl = 1,nbAloufs do                    -- dtection des aloufs cliques
      if Stylus.newPressinBox(zonesCliquables[bcl], x, y) then
         if aloufsRestantes[bcl] == 1 and selection < 3 then
            aloufsRestantes[bcl]= 2
            selection = selection+1
         elseif aloufsRestantes[bcl] == 2 and selection > 0 then
            aloufsRestantes[bcl]= 1
            selection = selection-1
         end
      end
   end
   if chxordi ~= 0 then   -- effacement des aloufs prises par l'ordi
      time = tmr:time()
      if time > 500 then
         tmr:reset()
         tmr:stop()
         for bcl = 1,nbAloufs do
            if aloufsRestantes[bcl] == 1 and chxordi > 0 then
               aloufsRestantes[bcl] = 0
               chxordi = chxordi - 1
            end
         end
      end
      btValidation.switched = false
   end
   Stylus.heldinCommand(btValidation, x, y)  -- Si on valide l'enlvement des aloufs
   if btValidation.switched and selection > 0 then
      temporisation(700)
      -- ce qui suit calcule le choix que va faire l'ordinateur
      math.randomseed(DateTime.getCurrentTime().second + DateTime.getCurrentTime().minute * 60)
      for k, v in ipairs(solution) do               -- l'ordi calcule la solution idale
         if v < countOnes then
            chxordi=countOnes-v
         elseif v == countOnes then
            chxordi = math.random(3)
         end
      end
      if 2*level+2 < countOnes then                 -- il faut aussi que l'ordi se trompe de temps en temps
         chxordi = math.random(3)
      end
      if chxordi > countOnes then                   -- et l'ordi ne prends pas plus d'alouf qu'il n'y en a 
         chxordi = countOnes 
      end
      message = "l'ordi a choisi d'en prendre "..chxordi.."."
      -- et ce qui suit dcompte les aloufs enleves par le joueur
      for bcl = 1, nbAloufs do
         if aloufsRestantes[bcl] == 2 then
            aloufsRestantes[bcl] = 0
         end
      end
      -- Dfinir si le jeu est termin et qui a gagn
-----------------------------------------------------------------------
      if chxordi == countOnes and chxordi ~= 0 then       -- si l'ordi prends la dernire alouf
         partiesGagnees = partiesGagnees + 1
         reinit()
      elseif countOnes == 0 then                  -- si le joueur prends la dernire alouf
         partiesPerdues = partiesPerdues + 1
         reinit()
      end
-----------------------------------------------------------------------
      tmr:start()
      selection = 0
   elseif btValidation.switched and selection <= 0 then
      message = "Vous devez prendre au moins une alouf."
      btValidation.switched = false
   end
   countOnes = 0    -- reinitialisation des compteurs
   countTwos = 0
   for k, v in ipairs(aloufsRestantes) do    -- comptage des alouf en jeu et slectionnes
      if v == 1 then 
         countOnes = countOnes + 1 
      elseif v == 2 then 
         countTwos = countTwos + 1 
      end
   end

   affichage()

end

-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
-- et on libre la mmoire
--

tmr = nil
btMoins = nil
btPlus = nil
btValidation = nil
couleur0 = nil
couleur1 = nil
couleur2 = nil
couleur3 = nil
couleurtxtgreen =nil
bcl = nil
nbAloufs = nil
solution = nil
aloufsRestantes = nil
zonesCliquables = nil
selection = nil
x = nil
y = nil
countOnes = nil
countTwos = nil
chxordi = nil
message = nil
nb = nil
level = nil
partiesGagnees = nil
partiesPerdues = nil
alouf0 = nil
alouf1 = nil
Font.destroy(font)
font = nil

---------
-- FIN --
---------                               
